.Dd July 11, 1994
.Dt MIDIDEVICE N
.Os
.Sh NAME
.Nm mididevice
.Nd "tclmidi command to get or modify MIDI device configuration values"
.Sh SYNOPSIS
.Nm
.Op name Op value | midithru Op value
.Sh DESCRIPTION
.Nm
is a
.Xr tclmidi 1
command that
gets or modifies the configurations
values for a MIDI device.
Currently, only two configuration values are supported, though
more might be added in the future.
.Pp
All arguments should be lists consisting of the parameter
name followed by additional arguments if needed followed by an optional value.
If a value for a parameter is not specified then the current
setting is reported.
If a value is specified then that parameter is changed.
.Pp
The different parameters are:
.Bl -tag -width midithru
.It name
This controls the device interface name.
The default value is
.Dq /dev/midi0 .
.It midithru
This paramter controls if data arriving at the \%MIDI IN
port is passed to the \%MIDI OUT port.
By default it is not.
The parameter is a boolean value and should be one of
.Dq yes ,
.Dq on ,
.Dq true ,
.Dq 1 ,
.Dq no ,
.Dq off ,
.Dq false
or
.Dq 0 .
.El
.Pp
If
.Nm
is called without any arguments, it merely checks for
device support.
.Sh RETURN VALUES
If called with no arguments,
.Nm
will return 1 if there is device support configured into
.Xr tclmidi 1
and
0 if not.
.Pp
If parameters are being set,
.Nm
will return nothing.
If parameters are being queried,
a list of lists will be returned.
Each sublist will contain the parameter
name and its associated value.
.Pp
If there is no device configured with
.Nm
will return 0 regardless of other arguments.
.Sh SEE ALSO
.Xr tclmidi 1
.Sh AUTHOR
Mike Durian - durian@boogie.com
