.Dd January 8, 1995
.Dt MIDITIME N
.Os
.Sh NAME
.Nm miditime
.Nd "tclmidi command to get or modify current MIDI device time"
.Sh SYNOPSIS
.Nm
{
smf |
smpte
}
.Op value
.Sh DESCRIPTION
.Nm
is a
.Xr tclmidi 1
command that
gets or sets the current time in the MIDI device.
.Pp
.Nm
can access the time in two forms.
The time can be represented as SMF ticks since the beginning of
the song, or in SMPTE form.
SMPTE form looks like hour:minute:second:frame:fractional_frame.
These forms can only be used if the driver supports them.
The first argument to the
.Nm
command cotrols which form is to be used.
The string ``smf'' specifies SMF for, while the string ``smpte''
specifies SMPTE form.
.Pp
If an optional secod argument is supplied to the
.Nm
command, it will be treated as a time value in the form determined
by the first argument, and the device will be set to that time.
This usage is not yet supported by
.Xr tclmidi 1 .
.Sh RETURN VALUES
If
.Nm
is being used to get the current time, the time will be return.
The syntax of the time will depend on the form being used.
If the driver does not support the specified form, the string
``ERR'' is returned.
.Pp
If the driver time is being set,
.Nm
will return a 1 if it succeeded in setting the time, or 0 if
it did not.
.Sh SEE ALSO
.Xr tclmidi 1
.Sh AUTHOR
Mike Durian - durian@boogie.com
